﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication46
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            NastavStav(Stav.START);
        }

        enum Stav { START, HRA, JEDNA, DVE, KONEC }
        Stav stav;

        void NastavStav( Stav jaky )
        {
            switch (jaky)
            {
                case Stav.START:
                    bSpustit.Visible = true;
                    bSkoncit.Visible = true;
                    bNaStart.Visible = false;
                    bVzdat.Visible = false;
                    tJmeno.Visible = true;
                    lNavod.Visible = true;
                    lNejlepsi.Visible = true;
                    lPocetTahu.Visible = false;
                    break;
                case Stav.HRA:
                    if (stav == Stav.START)
                        VytvorKarticky();
                    bSpustit.Visible = false;
                    bSkoncit.Visible = false;
                    bNaStart.Visible = false;
                    bVzdat.Visible = true;
                    tJmeno.Visible = false;
                    lNavod.Visible = false;
                    lNejlepsi.Visible = false;
                    lPocetTahu.Visible = false;
                    break;
                case Stav.JEDNA:
                case Stav.DVE:
                    bSpustit.Visible = false;
                    bSkoncit.Visible = false;
                    bNaStart.Visible = false;
                    bVzdat.Visible = true;
                    tJmeno.Visible = false;
                    lNavod.Visible = false;
                    lNejlepsi.Visible = false;
                    lPocetTahu.Visible = false;
                    break;
                case Stav.KONEC:
                    bSpustit.Visible = false;
                    bSkoncit.Visible = false;
                    bNaStart.Visible = true;
                    bVzdat.Visible = true;
                    tJmeno.Visible = false;
                    lNavod.Visible = false;
                    lNejlepsi.Visible = false;
                    lPocetTahu.Visible = true;
                    break;
                default:
                    break;
            }
            stav = jaky;
        }

        void VytvorKarticky()
        {
            int N = 6;
            int sx = ClientSize.Width / N;
            int sy = ClientSize.Height / N;

            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < N; j++)
                {
                    Button b = new Button();
                    b.Width = sx;
                    b.Height= sy;
                    b.Left = i * sx;
                    b.Top = j * sy;
                    b.Parent = this;

                    b.Click += KARTICKA_Click;
                    b.Tag = i * N + j;

                }
            }
        }

        private void KARTICKA_Click(object sender, EventArgs e)
        {
            MessageBox.Show(((Button)sender).Tag.ToString());
        }


        private void bSpustit_Click(object sender, EventArgs e)
        {
            NastavStav(Stav.HRA);
        }
    }
}
