﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication48
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            bmp = new Bitmap(2000, 1000);
            g = Graphics.FromImage(bmp);
            pictureBox1.Image = bmp;
        }
        Bitmap bmp;
        Graphics g;



        private void button1_Click(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox2.Image;
            Bitmap vyrez = vzor.Clone(new Rectangle(100, 100, 200, 200),
                System.Drawing.Imaging.PixelFormat.DontCare);
            g.DrawImage(vyrez, 0, 0);
            pictureBox1.Refresh();
        }


        private void button1_Click_6(object sender, EventArgs e)
        {
            Font pismo = new System.Drawing.Font("Arial", 72);

            //g.DrawString("ABCD", button1.Font, Brushes.Violet, 10, 10);
            g.DrawString("ABCD", pismo, Brushes.Violet, 10, 10);
            pictureBox1.Refresh();
        }



        private void button1_Click_4(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox2.Image;

            for (int y = 0; y < vzor.Height; y++)
            {
                for (int x = 0; x < vzor.Width; x++)
                {
                    int xx = x + (int)(50 + 50 * Math.Sin(y / 20.00));
                    if ((xx < 0) || (xx > vzor.Width-1))
                        xx = x;
                    int yy = y;
                    
                    Color c = vzor.GetPixel(xx, yy);
                    bmp.SetPixel(x, y, c);
                }
                pictureBox1.Refresh();
            }
        }



        private void button1_Click_5(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox2.Image;
            for (int y = 0; y < vzor.Height-5; y++)
            {
                for (int x = 0; x < vzor.Width-5; x++)
                {
                    Color c = vzor.GetPixel(x, y);

                    int R = c.R;
                    int G = c.G;
                    int B = c.B;

                    int svetlost =
                        (int)(0.2989 * R + 0.5866 * G + (1 - 0.2989 - 0.5866) * B);

                    int KROK = 2;
                    c = vzor.GetPixel(x+KROK, y+KROK);

                    R = c.R;
                    G = c.G;
                    B = c.B;

                    int svetlost2 =
                        (int)(0.2989 * R + 0.5866 * G + (1 - 0.2989 - 0.5866) * B);

                    int rozdil = (svetlost - svetlost2) / 2 + 128;

                    c = Color.FromArgb(255, rozdil, rozdil, rozdil);

                    bmp.SetPixel(x, y, c);

                }
                pictureBox1.Refresh();
            }
        }

        private void button1_Click_3(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap) pictureBox2.Image;
            int[] zbytky;
            int[] budouci_zbytky = new int[vzor.Width];

            for (int y = 0; y < vzor.Height; y++)
            {
                zbytky = budouci_zbytky;
                budouci_zbytky = new int[vzor.Width];

                for (int x = 0; x < vzor.Width; x++)    
                {
                    Color c = vzor.GetPixel(x, y);

                    int R = c.R;
                    int G = c.R;
                    int B = c.R;

                    int svetlost = 
                        (int)(0.2989 * R + 0.5866 * G + (1 - 0.2989 - 0.5866) * B)
                        + zbytky[x];

                    // c = Color.FromArgb(255, R, G, B);
                    //c = Color.FromArgb(255, svetlost, svetlost, svetlost);

                    int PRAH = 255;

                    if (svetlost > PRAH)
                    {
                        c = Color.White;
                        svetlost -= PRAH;
                    }
                    else
                        c = Color.Black;

                    bmp.SetPixel(x, y, c);

                    if (x<vzor.Width-1)
                        zbytky[x+1] += svetlost/4;
                    if (x>0)
                        budouci_zbytky[x-1] += svetlost/4;
                    budouci_zbytky[x] += svetlost/4;
                    if (x<vzor.Width-1)
                        budouci_zbytky[x+1] += svetlost/4;

                }
                pictureBox1.Refresh();
            }
        }
    }
}
